Index: gnu/usr.bin/perl/t/lib/croak/toke
===================================================================
RCS file: /tmp/cvs/src/gnu/usr.bin/perl/t/lib/croak/toke,v
retrieving revision 1.3
diff -u -p -u -p -r1.3 toke
--- gnu/usr.bin/perl/t/lib/croak/toke	13 Feb 2019 21:15:31 -0000	1.3
+++ gnu/usr.bin/perl/t/lib/croak/toke	13 May 2019 15:13:25 -0000
@@ -480,3 +480,12 @@ Bareword found where operator expected a
 	(Missing operator before p0?)
 syntax error at - line 2, near "2p0"
 Execution of - aborted due to compilation errors.
+########
+# NAME [perl #132158] format with syntax errors
+format=
+@
+=h
+=cut
+EXPECT
+syntax error at - line 4, next token ???
+Execution of - aborted due to compilation errors.
Index: gnu/usr.bin/perl/t/op/for.t
===================================================================
RCS file: /tmp/cvs/src/gnu/usr.bin/perl/t/op/for.t,v
retrieving revision 1.3
diff -u -p -u -p -r1.3 for.t
--- gnu/usr.bin/perl/t/op/for.t	13 Feb 2019 21:15:31 -0000	1.3
+++ gnu/usr.bin/perl/t/op/for.t	13 May 2019 15:13:25 -0000
@@ -5,7 +5,7 @@ BEGIN {
     require "./test.pl";
 }
 
-plan(124);
+plan(126);
 
 # A lot of tests to check that reversed for works.
 
@@ -663,4 +663,18 @@ is(fscope(), 1, 'return via loop in sub'
         $i++;
     }
     is($foo, "outside", "RT #123994 array outside");
+}
+
+# RT #133558 'reverse' under AIX was causing loop to terminate
+# immediately, probably due to compiler bug
+
+{
+    my @a = qw(foo);
+    my @b;
+    push @b, $_ for (reverse @a);
+    is "@b", "foo", " RT #133558 reverse array";
+
+    @b = ();
+    push @b, $_ for (reverse 'bar');
+    is "@b", "bar", " RT #133558 reverse list";
 }
Index: gnu/usr.bin/perl/t/op/pack.t
===================================================================
RCS file: /tmp/cvs/src/gnu/usr.bin/perl/t/op/pack.t,v
retrieving revision 1.16
diff -u -p -u -p -r1.16 pack.t
--- gnu/usr.bin/perl/t/op/pack.t	13 Feb 2019 21:15:31 -0000	1.16
+++ gnu/usr.bin/perl/t/op/pack.t	13 May 2019 15:13:25 -0000
@@ -12,7 +12,7 @@ my $no_endianness = $] > 5.009 ? '' :
 my $no_signedness = $] > 5.009 ? '' :
   "Signed/unsigned pack modifiers not available on this perl";
 
-plan tests => 14717;
+plan tests => 14718;
 
 use strict;
 use warnings qw(FATAL all);
@@ -2080,4 +2080,11 @@ SKIP:
 
     fresh_perl_like('pack "c10f1073741824"', qr/Out of memory during pack/, { stderr => 1 },
 		    "integer overflow calculating allocation (multiply)");
+}
+
+{
+    # [perl #132655] heap-buffer-overflow READ of size 11
+    # only expect failure under ASAN (and maybe valgrind)
+    fresh_perl_is('0.0 + unpack("u", "ab")', "", { stderr => 1 },
+                  "ensure unpack u of invalid data nul terminates result");
 }
Index: gnu/usr.bin/perl/t/op/repeat.t
===================================================================
RCS file: /tmp/cvs/src/gnu/usr.bin/perl/t/op/repeat.t,v
retrieving revision 1.11
diff -u -p -u -p -r1.11 repeat.t
--- gnu/usr.bin/perl/t/op/repeat.t	13 Feb 2019 21:15:31 -0000	1.11
+++ gnu/usr.bin/perl/t/op/repeat.t	13 May 2019 15:13:25 -0000
@@ -6,7 +6,7 @@ BEGIN {
     set_up_inc( '../lib' );
 }
 
-plan(tests => 49);
+plan(tests => 50);
 
 # compile time
 
@@ -192,3 +192,85 @@ fresh_perl_like(
 
 eval q{() = (() or ((0) x 0)); 1};
 is($@, "", "RT #130247");
+
+# yes, the newlines matter
+fresh_perl_is(<<'PERL', "", { stderr => 1 }, "(perl #133778) MARK mishandling");
+map{s[][];eval;0}<DATA>__END__
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+()x0
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+0
+PERL
Index: gnu/usr.bin/perl/t/re/script_run.t
===================================================================
RCS file: /tmp/cvs/src/gnu/usr.bin/perl/t/re/script_run.t,v
retrieving revision 1.1.1.1
diff -u -p -u -p -r1.1.1.1 script_run.t
--- gnu/usr.bin/perl/t/re/script_run.t	13 Feb 2019 21:11:42 -0000	1.1.1.1
+++ gnu/usr.bin/perl/t/re/script_run.t	13 May 2019 15:13:25 -0000
@@ -51,8 +51,8 @@ foreach my $type ('script_run', 'sr', 'a
     unlike("\N{HEBREW LETTER ALEF}\N{HEBREW LETTER TAV}\N{MODIFIER LETTER SMALL Y}", $script_run, "Hebrew then Latin isn't a script run");
     like("9876543210\N{DESERET SMALL LETTER WU}", $script_run, "0-9 are the digits for Deseret");
     like("\N{DESERET SMALL LETTER WU}9876543210", $script_run, "Also when they aren't in the initial position");
-    unlike("\N{DESERET SMALL LETTER WU}\N{FULLWIDTH DIGIT FIVE}", $script_run, "Fullwidth digits aren't the digits for Deseret");
-    unlike("\N{FULLWIDTH DIGIT SIX}\N{DESERET SMALL LETTER LONG I}", $script_run, "... likewise if the digits come first");
+    like("\N{DESERET SMALL LETTER WU}\N{FULLWIDTH DIGIT FIVE}", $script_run, "Fullwidth digits may be digits for Deseret");
+    like("\N{FULLWIDTH DIGIT SIX}\N{DESERET SMALL LETTER LONG I}", $script_run, "... likewise if the digits come first");
 
     like("1234567890\N{ARABIC LETTER ALEF}", $script_run, "[0-9] work for Arabic");
     unlike("1234567890\N{ARABIC LETTER ALEF}\N{ARABIC-INDIC DIGIT FOUR}\N{ARABIC-INDIC DIGIT FIVE}", $script_run, "... but not in combination with real ARABIC digits");
@@ -96,5 +96,20 @@ foreach my $type ('script_run', 'sr', 'a
 
       like("abc", qr/(*asr:a[bc]*c)/, "Outer asr works on a run");
     unlike("abc", qr/(*asr:a(*asr:[bc]*)c)/, "Nested asr works to exclude some things");
+
+    like("A\x{ff10}\x{ff19}B", qr/^(*sr:.{4})/,
+         "Non-ASCII Common digits work with Latin"); # perl #133547
+    like("A\x{ff10}BC", qr/^(*sr:.{4})/,
+         "Non-ASCII Common digits work with Latin"); # perl #133547
+    like("A\x{1d7ce}\x{1d7cf}B", qr/^(*sr:.{4})/,
+         "Non-ASCII Common digits work with Latin"); # perl #133547
+    like("A\x{1d7ce}BC", qr/^(*sr:.{4})/,
+         "Non-ASCII Common digits work with Latin"); # perl #133547
+    like("\x{1d7ce}\x{1d7cf}AB", qr/^(*sr:.{4})/,
+         "Non-ASCII Common digits work with Latin"); # perl #133547
+    like("α\x{1d7ce}βγ", qr/^(*sr:.{4})/,
+         "Non-ASCII Common digits work with Greek"); # perl #133547
+    like("\x{1d7ce}αβγ", qr/^(*sr:.{4})/,
+         "Non-ASCII Common digits work with Greek"); # perl #133547
 
 done_testing();
Index: gnu/usr.bin/perl/t/re/subst.t
===================================================================
RCS file: /tmp/cvs/src/gnu/usr.bin/perl/t/re/subst.t,v
retrieving revision 1.4
diff -u -p -u -p -r1.4 subst.t
--- gnu/usr.bin/perl/t/re/subst.t	13 Feb 2019 21:15:32 -0000	1.4
+++ gnu/usr.bin/perl/t/re/subst.t	13 May 2019 15:13:25 -0000
@@ -11,7 +11,7 @@ BEGIN {
     require './loc_tools.pl';
 }
 
-plan(tests => 276);
+plan(tests => 277);
 
 $_ = 'david';
 $a = s/david/rules/r;
@@ -1174,5 +1174,6 @@ __EOF__
     is $lines, 4, "RT #131930";
 }
 
-
-
+{
+    fresh_perl_is("s//00000000000format            \0          '0000000\\x{800}/;eval", "", {}, "RT #133882");
+}
Index: gnu/usr.bin/perl/t/run/switches.t
===================================================================
RCS file: /tmp/cvs/src/gnu/usr.bin/perl/t/run/switches.t,v
retrieving revision 1.3
diff -u -p -u -p -r1.3 switches.t
--- gnu/usr.bin/perl/t/run/switches.t	13 Feb 2019 21:15:32 -0000	1.3
+++ gnu/usr.bin/perl/t/run/switches.t	13 May 2019 15:13:25 -0000
@@ -429,7 +429,7 @@ __EOF__
 
     # exit or die should leave original content in file
     for my $inplace (qw/-i -i.bak/) {
-        for my $prog (qw/die exit/) {
+        for my $prog ("die", "exit 1") {
             open my $fh, ">", $work or die "$0: failed to open '$work': $!";
             print $fh $yada;
             close $fh or die "Failed to close: $!";
@@ -443,7 +443,7 @@ __EOF__
             my $data = do { local $/; <$in> };
             close $in;
             is ($data, $yada, "check original content still in file");
-            unlink $work;
+            unlink $work, "$work.bak";
         }
     }
 
Index: gnu/usr.bin/perl/vms/descrip_mms.template
===================================================================
RCS file: /tmp/cvs/src/gnu/usr.bin/perl/vms/descrip_mms.template,v
retrieving revision 1.6
diff -u -p -u -p -r1.6 descrip_mms.template
--- gnu/usr.bin/perl/vms/descrip_mms.template	13 Feb 2019 21:15:32 -0000	1.6
+++ gnu/usr.bin/perl/vms/descrip_mms.template	13 May 2019 15:13:25 -0000
@@ -307,7 +307,7 @@ utils : $(utils1) $(utils2) $(utils3) $(
 extra.pods : miniperl
 	@ @extra_pods.com
 
-PERLDELTA_CURRENT = [.pod]perl5281delta.pod
+PERLDELTA_CURRENT = [.pod]perl5282delta.pod
 
 $(PERLDELTA_CURRENT) : [.pod]perldelta.pod
 	Copy/NoConfirm/Log $(MMS$SOURCE) $(PERLDELTA_CURRENT)
Index: gnu/usr.bin/perl/win32/GNUmakefile
===================================================================
RCS file: /tmp/cvs/src/gnu/usr.bin/perl/win32/GNUmakefile,v
retrieving revision 1.9
diff -u -p -u -p -r1.9 GNUmakefile
--- gnu/usr.bin/perl/win32/GNUmakefile	13 Feb 2019 21:18:39 -0000	1.9
+++ gnu/usr.bin/perl/win32/GNUmakefile	13 May 2019 15:13:25 -0000
@@ -64,7 +64,7 @@ INST_TOP := $(INST_DRV)\perl
 # versioned installation can be obtained by setting INST_TOP above to a
 # path that includes an arbitrary version string.
 #
-#INST_VER	:= \5.28.1
+#INST_VER	:= \5.28.2
 
 #
 # Comment this out if you DON'T want your perl installation to have
@@ -722,6 +722,15 @@ else ifeq ($(CCTYPE),MSVC141)
 DEFINES		+= -D_WINSOCK_DEPRECATED_NO_WARNINGS
 endif
 
+# The Windows Server 2003 SP1 SDK compiler only defines _configthreadlocale() if
+# _MT is defined, i.e. when using /MT (the LIBCMT.lib version of the CRT), which
+# the perl build doesn't use. We therefore specify NO_THREAD_SAFE_LOCALE so that
+# perl.h doesn't set USE_THREAD_SAFE_LOCALE, which it otherwise would do since
+# _MSC_VER is 1400 for this compiler (as per MSVC80).
+ifeq ($(CCTYPE),SDK2003SP1)
+DEFINES		+= -DNO_THREAD_SAFE_LOCALE
+endif
+
 # In VS 2005 (VC++ 8.0) Microsoft changes time_t from 32-bit to
 # 64-bit, even in 32-bit mode.  It also provides the _USE_32BIT_TIME_T
 # preprocessor option to revert back to the old functionality for
@@ -1679,7 +1688,7 @@ utils: $(HAVEMINIPERL) ..\utils\Makefile
 	copy ..\README.tw       ..\pod\perltw.pod
 	copy ..\README.vos      ..\pod\perlvos.pod
 	copy ..\README.win32    ..\pod\perlwin32.pod
-	copy ..\pod\perldelta.pod ..\pod\perl5281delta.pod
+	copy ..\pod\perldelta.pod ..\pod\perl5282delta.pod
 	$(MINIPERL) -I..\lib $(PL2BAT) $(UTILS)
 	$(MINIPERL) -I..\lib ..\autodoc.pl ..
 	$(MINIPERL) -I..\lib ..\pod\perlmodlib.PL -q ..
@@ -1778,7 +1787,7 @@ distclean: realclean
 	-if exist $(LIBDIR)\Win32API rmdir /s /q $(LIBDIR)\Win32API
 	-if exist $(LIBDIR)\XS rmdir /s /q $(LIBDIR)\XS
 	-cd $(PODDIR) && del /f *.html *.bat roffitall \
-	    perl5281delta.pod perlaix.pod perlamiga.pod perlandroid.pod \
+	    perl5282delta.pod perlaix.pod perlamiga.pod perlandroid.pod \
 	    perlapi.pod perlbs2000.pod perlce.pod perlcn.pod perlcygwin.pod \
 	    perldos.pod perlfreebsd.pod perlhaiku.pod perlhpux.pod \
 	    perlhurd.pod perlintern.pod perlirix.pod perljp.pod perlko.pod \
Index: gnu/usr.bin/perl/win32/Makefile
===================================================================
RCS file: /tmp/cvs/src/gnu/usr.bin/perl/win32/Makefile,v
retrieving revision 1.34
diff -u -p -u -p -r1.34 Makefile
--- gnu/usr.bin/perl/win32/Makefile	13 Feb 2019 21:18:39 -0000	1.34
+++ gnu/usr.bin/perl/win32/Makefile	13 May 2019 15:13:25 -0000
@@ -38,7 +38,7 @@ INST_TOP	= $(INST_DRV)\perl
 # versioned installation can be obtained by setting INST_TOP above to a
 # path that includes an arbitrary version string.
 #
-#INST_VER	= \5.28.1
+#INST_VER	= \5.28.2
 
 #
 # Comment this out if you DON'T want your perl installation to have
@@ -553,6 +553,15 @@ DEFINES		= $(DEFINES) -D_CRT_SECURE_NO_D
 DEFINES		= $(DEFINES) -D_WINSOCK_DEPRECATED_NO_WARNINGS
 !ENDIF
 
+# The Windows Server 2003 SP1 SDK compiler only defines _configthreadlocale() if
+# _MT is defined, i.e. when using /MT (the LIBCMT.lib version of the CRT), which
+# the perl build doesn't use. We therefore specify NO_THREAD_SAFE_LOCALE so that
+# perl.h doesn't set USE_THREAD_SAFE_LOCALE, which it otherwise would do since
+# _MSC_VER is 1400 for this compiler (as per MSVC80).
+!IF "$(CCTYPE)" == "SDK2003SP1"
+DEFINES		= $(DEFINES) -DNO_THREAD_SAFE_LOCALE
+!ENDIF
+
 # In VS 2005 (VC++ 8.0) Microsoft changes time_t from 32-bit to
 # 64-bit, even in 32-bit mode.  It also provides the _USE_32BIT_TIME_T
 # preprocessor option to revert back to the old functionality for
@@ -1282,7 +1291,7 @@ utils: $(PERLEXE) ..\utils\Makefile
 	copy ..\README.tw       ..\pod\perltw.pod
 	copy ..\README.vos      ..\pod\perlvos.pod
 	copy ..\README.win32    ..\pod\perlwin32.pod
-	copy ..\pod\perldelta.pod ..\pod\perl5281delta.pod
+	copy ..\pod\perldelta.pod ..\pod\perl5282delta.pod
 	cd ..\win32
 	$(PERLEXE) $(PL2BAT) $(UTILS)
 	$(MINIPERL) -I..\lib ..\autodoc.pl ..
@@ -1383,7 +1392,7 @@ distclean: realclean
 	-if exist $(LIBDIR)\Win32API rmdir /s /q $(LIBDIR)\Win32API
 	-if exist $(LIBDIR)\XS rmdir /s /q $(LIBDIR)\XS
 	-cd $(PODDIR) && del /f *.html *.bat roffitall \
-	    perl5281delta.pod perlaix.pod perlamiga.pod perlandroid.pod \
+	    perl5282delta.pod perlaix.pod perlamiga.pod perlandroid.pod \
 	    perlapi.pod perlbs2000.pod perlce.pod perlcn.pod perlcygwin.pod \
 	    perldos.pod perlfreebsd.pod perlhaiku.pod perlhpux.pod \
 	    perlhurd.pod perlintern.pod perlirix.pod perljp.pod perlko.pod \
Index: gnu/usr.bin/perl/win32/makefile.mk
===================================================================
RCS file: /tmp/cvs/src/gnu/usr.bin/perl/win32/makefile.mk,v
retrieving revision 1.34
diff -u -p -u -p -r1.34 makefile.mk
--- gnu/usr.bin/perl/win32/makefile.mk	13 Feb 2019 21:18:39 -0000	1.34
+++ gnu/usr.bin/perl/win32/makefile.mk	13 May 2019 15:13:25 -0000
@@ -45,7 +45,7 @@ INST_TOP	*= $(INST_DRV)\perl
 # versioned installation can be obtained by setting INST_TOP above to a
 # path that includes an arbitrary version string.
 #
-#INST_VER	*= \5.28.1
+#INST_VER	*= \5.28.2
 
 #
 # Comment this out if you DON'T want your perl installation to have
@@ -695,6 +695,15 @@ DEFINES		+= -D_CRT_SECURE_NO_DEPRECATE -
 DEFINES		+= -D_WINSOCK_DEPRECATED_NO_WARNINGS
 .ENDIF
 
+# The Windows Server 2003 SP1 SDK compiler only defines _configthreadlocale() if
+# _MT is defined, i.e. when using /MT (the LIBCMT.lib version of the CRT), which
+# the perl build doesn't use. We therefore specify NO_THREAD_SAFE_LOCALE so that
+# perl.h doesn't set USE_THREAD_SAFE_LOCALE, which it otherwise would do since
+# _MSC_VER is 1400 for this compiler (as per MSVC80).
+.IF "$(CCTYPE)" == "SDK2003SP1"
+DEFINES		+= -DNO_THREAD_SAFE_LOCALE
+.ENDIF
+
 # In VS 2005 (VC++ 8.0) Microsoft changes time_t from 32-bit to
 # 64-bit, even in 32-bit mode.  It also provides the _USE_32BIT_TIME_T
 # preprocessor option to revert back to the old functionality for
@@ -1622,7 +1631,7 @@ utils: $(HAVEMINIPERL) ..\utils\Makefile
 	copy ..\README.tw       ..\pod\perltw.pod
 	copy ..\README.vos      ..\pod\perlvos.pod
 	copy ..\README.win32    ..\pod\perlwin32.pod
-	copy ..\pod\perldelta.pod ..\pod\perl5281delta.pod
+	copy ..\pod\perldelta.pod ..\pod\perl5282delta.pod
 	$(MINIPERL) -I..\lib $(PL2BAT) $(UTILS)
 	$(MINIPERL) -I..\lib ..\autodoc.pl ..
 	$(MINIPERL) -I..\lib ..\pod\perlmodlib.PL -q ..
@@ -1721,7 +1730,7 @@ distclean: realclean
 	-if exist $(LIBDIR)\Win32API rmdir /s /q $(LIBDIR)\Win32API
 	-if exist $(LIBDIR)\XS rmdir /s /q $(LIBDIR)\XS
 	-cd $(PODDIR) && del /f *.html *.bat roffitall \
-	    perl5281delta.pod perlaix.pod perlamiga.pod perlandroid.pod \
+	    perl5282delta.pod perlaix.pod perlamiga.pod perlandroid.pod \
 	    perlapi.pod perlbs2000.pod perlce.pod perlcn.pod perlcygwin.pod \
 	    perldos.pod perlfreebsd.pod perlhaiku.pod perlhpux.pod \
 	    perlhurd.pod perlintern.pod perlirix.pod perljp.pod perlko.pod \
Index: gnu/usr.bin/perl/win32/pod.mak
===================================================================
RCS file: /tmp/cvs/src/gnu/usr.bin/perl/win32/pod.mak,v
retrieving revision 1.21
diff -u -p -u -p -r1.21 pod.mak
--- gnu/usr.bin/perl/win32/pod.mak	13 Feb 2019 21:15:33 -0000	1.21
+++ gnu/usr.bin/perl/win32/pod.mak	13 May 2019 15:13:25 -0000
@@ -53,8 +53,10 @@ POD = perl.pod	\
 	perl5260delta.pod	\
 	perl5261delta.pod	\
 	perl5262delta.pod	\
+	perl5263delta.pod	\
 	perl5280delta.pod	\
 	perl5281delta.pod	\
+	perl5282delta.pod	\
 	perl561delta.pod	\
 	perl56delta.pod	\
 	perl581delta.pod	\
@@ -203,8 +205,10 @@ MAN = perl.man	\
 	perl5260delta.man	\
 	perl5261delta.man	\
 	perl5262delta.man	\
+	perl5263delta.man	\
 	perl5280delta.man	\
 	perl5281delta.man	\
+	perl5282delta.man	\
 	perl561delta.man	\
 	perl56delta.man	\
 	perl581delta.man	\
@@ -353,8 +357,10 @@ HTML = perl.html	\
 	perl5260delta.html	\
 	perl5261delta.html	\
 	perl5262delta.html	\
+	perl5263delta.html	\
 	perl5280delta.html	\
 	perl5281delta.html	\
+	perl5282delta.html	\
 	perl561delta.html	\
 	perl56delta.html	\
 	perl581delta.html	\
@@ -503,8 +509,10 @@ TEX = perl.tex	\
 	perl5260delta.tex	\
 	perl5261delta.tex	\
 	perl5262delta.tex	\
+	perl5263delta.tex	\
 	perl5280delta.tex	\
 	perl5281delta.tex	\
+	perl5282delta.tex	\
 	perl561delta.tex	\
 	perl56delta.tex	\
 	perl581delta.tex	\
